// 5.25" mounting adapter for 2.5" + 3.5" HDD pair
// inspired by https://www.thingiverse.com/thing:2795992
// re-made from scratch for easier printing and correct hole positions
// print without supports
// (c) Vitaliy Filippov 2018, license: CC-BY-SA 4.0

difference() {
    union() {
        //import("/var/home/vitali/hui/25__35_hdd_to_525_adapter.stl");
        translate([-19.5, -17.5, 0]) cube(size=[3,21,41]);
        translate([32.5, -17.5, 0]) cube(size=[3,21,41]);
        translate([-19.5, 0.5, 0]) cube(size=[55,3.15,41]);
        translate([-37, 0.5, 18]) cube(size=[90,3.15,41-18]);
        translate([-37, 3.65, 0]) rotate([90,0,0]) linear_extrude(height=3.15) polygon(points=[[0,18],[18,0],[18,18]]);
        translate([53, 0.5, 0]) rotate([90,0,180]) linear_extrude(height=3.15) polygon(points=[[0,18],[18,0],[18,18]]);
        translate([-52, -15.5, 0]) rotate([90,0,0]) linear_extrude(height=2) polygon(points=[[0,33],[33,0],[33,33]]);
        translate([68, -17.5, 0]) rotate([90,0,180]) linear_extrude(height=2) polygon(points=[[0,33],[33,0],[33,33]]);
        translate([-0.5, -15.5, 0]) rotate([90,0,0]) linear_extrude(height=2) polygon(points=[[0,33],[33,0],[33,33]]);
        translate([16.5, -17.5, 0]) rotate([90,0,180]) linear_extrude(height=2) polygon(points=[[0,33],[33,0],[33,33]]);
        translate([-37, -33, 0]) cube(size=[90,2,12]);
        translate([-52, -17.5, 33]) cube(size=[120,2,8]);
        translate([-19.5, -33, 0]) cube(size=[3,21,12]);
        translate([32.5, -33, 0]) cube(size=[3,21,12]);
        translate([-16.5, -21.5, 6+12]) rotate([-90,0,90]) linear_extrude(height=3) polygon(points=[[0,6],[6,0],[6,6]]);
        translate([35.5, -21.5, 6+12]) rotate([-90,0,90]) linear_extrude(height=3) polygon(points=[[0,6],[6,0],[6,6]]);
    }
    //#translate([-42, -18, 31]) cube(size=[101.6,2,5]);
    translate([59.5, -15, 33.5]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([59.5-101.6, -15, 33.5]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    //#translate([-30.25, -33, 3]) cube(size=[76.6,2,5]);
    translate([-30.25, -30, 5.5]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([-30.25+76.6, -30, 5.5]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([-31.5, 5, 20]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([-31.5, 5, 32]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([47.5, 5, 20]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
    translate([47.5, 5, 32]) rotate([90,0,0]) cylinder(h=5, r=1.75, $fn=32);
}
